using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;
using System.Collections.Generic;
using System.Threading.Tasks;

using TestProject.Data;
using TestProject.Models;

namespace TestProject.Controllers
{
    /// <summary>
    ///  Ʈѷ
    /// </summary>
    [ApiController]
    [Route("api/[controller]")]
    public class TodoController : ControllerBase
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// ͺ̽ ؽƮ
        /// </summary>
        private readonly DatabaseContext context;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - TodoController(context)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="context">ͺ̽ ؽƮ</param>
        public TodoController(DatabaseContext context)
        {
            this.context = context;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region GET óϱ - Get()

        /// <summary>
        /// GET óϱ
        /// </summary>
        /// <returns> Ʈ ½ũ</returns>
        [HttpGet]
        public async Task<List<TodoModel>> Get()
        {
             return await this.context.Todo.AsNoTracking().ToListAsync();
        }

        #endregion
        #region GET óϱ - Get(id)

        /// <summary>
        /// GET óϱ
        /// </summary>
        /// <param name="id">ID</param>
        /// <returns> ׼  ½ũ</returns>
        [HttpGet("{id}")]
        public async Task<ActionResult<TodoModel>> Get(long id)
        {
            TodoModel todo = await this.context.Todo.FindAsync(id);

            if(todo == null)
            {
                return NotFound();
            }

            return todo;
        }

        #endregion
        #region POST óϱ - Post(todo)

        /// <summary>
        /// POST óϱ
        /// </summary>
        /// <param name="todo"></param>
        /// <returns>׼  ½ũ</returns>
        [HttpPost]
        public async Task<IActionResult> Post(TodoModel todo)
        {
            this.context.Todo.Add(todo);

            await this.context.SaveChangesAsync();

            return CreatedAtAction(nameof(Get), new { id = todo.ID, todo });
        }

        #endregion
        #region PUT óϱ - Put(id, todo)

        /// <summary>
        /// PUT óϱ
        /// </summary>
        /// <param name="id">ID</param>
        /// <param name="todo"></param>
        /// <returns>׼  ½ũ</returns>
        [HttpPut("{id}")]
        public async Task<IActionResult> Put(long id, TodoModel todo)
        {
            if(todo.ID != id)
            {
                return BadRequest();
            }

            this.context.Update(todo);

            await this.context.SaveChangesAsync();

            return NoContent();
        }

        #endregion
        #region DELETE óϱ - Delete(id)

        /// <summary>
        /// DELETE óϱ
        /// </summary>
        /// <param name="id">ID</param>
        /// <returns>׼  ½ũ</returns>
        [HttpDelete("{id}")]
        public async Task<IActionResult> Delete(long id)
        {
            TodoModel todo = await this.context.Todo.FindAsync(id);

            if(todo == null)
            {
                return NotFound();
            }

            this.context.Todo.Remove(todo);

            await this.context.SaveChangesAsync();

            return NoContent();
        }

        #endregion
    }
}