using Microsoft.AspNetCore.Hosting;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Hosting;

using TestProject.Data;
using TestProject.Models;

namespace TestProject
{
    /// <summary>
    /// α׷
    /// </summary>
    public class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region α׷ ϱ - Main(argumentArray)

        /// <summary>
        /// α׷ ϱ
        /// </summary>
        /// <param name="argumentArray"> 迭</param>
        public static void Main(string[] argumentArray)
        {
            IHost host = CreateHostBuilder(argumentArray).Build();

            using(IServiceScope serviceScope = host.Services.CreateScope())
            {
                DatabaseContext context = serviceScope.ServiceProvider.GetRequiredService<DatabaseContext>();

                SetData(context);

                context.SaveChanges();
            }

            host.Run();
        }

        #endregion
        #region ȣƮ  ϱ - CreateHostBuilder(argumentArray)

        /// <summary>
        /// ȣƮ  ϱ
        /// </summary>
        /// <param name="argumentArray"> 迭</param>
        /// <returns>ȣƮ </returns>
        public static IHostBuilder CreateHostBuilder(string[] argumentArray) =>
            Host.CreateDefaultBuilder(argumentArray)
                .ConfigureWebHostDefaults
                (
                    builder =>
                    {
                        builder.UseStartup<Startup>();
                    }
                );

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Private

        #region  ϱ - SetData(context)

        /// <summary>
        ///  ϱ
        /// </summary>
        /// <param name="context">ͺ̽ ؽƮ</param>
        private static void SetData(DatabaseContext context)
        {
            context.Todo.Add(new TodoModel { Name = "Task #1", IsComplete = true  });
            context.Todo.Add(new TodoModel { Name = "Task #2", IsComplete = false });
            context.Todo.Add(new TodoModel { Name = "Task #3", IsComplete = false });
            context.Todo.Add(new TodoModel { Name = "Task #4", IsComplete = true  });
        }

        #endregion
    }
}